diff --git a/include/linux/dma-mapping.h b/include/linux/dma-mapping.h
index 2c74e68b0567..bb541f8944e5 100644
--- a/include/linux/dma-mapping.h
+++ b/include/linux/dma-mapping.h
@@ -11,6 +11,7 @@
 #include <linux/scatterlist.h>
 #include <linux/bug.h>
 #include <linux/mem_encrypt.h>
+#include <linux/iommu.h>
 
 /**
  * List of possible attributes associated with a DMA mapping. The semantics
@@ -82,6 +83,7 @@ struct dma_iova_state {
 	size_t size;
 	enum dma_data_direction dir;
 	u8 use_iova : 1;
+	size_t range_size;
 };
 
 static inline void dma_init_iova_state(struct dma_iova_state *state,
@@ -173,6 +175,11 @@ int dma_mmap_noncontiguous(struct device *dev, struct vm_area_struct *vma,
 void dma_set_iova_state(struct dma_iova_state *state, struct page *page,
 			size_t size);
 bool dma_can_use_iova(struct dma_iova_state *state);
+int dma_start_range(struct dma_iova_state *state);
+void dma_end_range(struct dma_iova_state *state);
+dma_addr_t dma_link_range_attrs(struct dma_iova_state *state, phys_addr_t phys,
+				size_t size, unsigned long attrs);
+void dma_unlink_range_attrs(struct dma_iova_state *state, unsigned long attrs);
 #else /* CONFIG_HAS_DMA */
 static inline int dma_alloc_iova_unaligned(struct dma_iova_state *state,
 					   phys_addr_t phys, size_t size)
@@ -319,6 +326,23 @@ static inline bool dma_can_use_iova(struct dma_iova_state *state)
 {
 	return false;
 }
+static inline int dma_start_range(struct dma_iova_state *state)
+{
+	return -EOPNOTSUPP;
+}
+static inline void dma_end_range(struct dma_iova_state *state)
+{
+}
+static inline dma_addr_t dma_link_range_attrs(struct dma_iova_state *state,
+					      phys_addr_t phys, size_t size,
+					      unsigned long attrs)
+{
+	return DMA_MAPPING_ERROR;
+}
+static inline void dma_unlink_range_attrs(struct dma_iova_state *state,
+					  unsigned long attrs)
+{
+}
 #endif /* CONFIG_HAS_DMA */
 
 #if defined(CONFIG_HAS_DMA) && defined(CONFIG_DMA_NEED_SYNC)
@@ -513,6 +537,8 @@ static inline void dma_sync_sgtable_for_device(struct device *dev,
 #define dma_unmap_page(d, a, s, r) dma_unmap_page_attrs(d, a, s, r, 0)
 #define dma_get_sgtable(d, t, v, h, s) dma_get_sgtable_attrs(d, t, v, h, s, 0)
 #define dma_mmap_coherent(d, v, c, h, s) dma_mmap_attrs(d, v, c, h, s, 0)
+#define dma_link_range(d, p, o) dma_link_range_attrs(d, p, o, 0)
+#define dma_unlink_range(d) dma_unlink_range_attrs(d, 0)
 
 bool dma_coherent_ok(struct device *dev, phys_addr_t phys, size_t size);
 
diff --git a/kernel/dma/mapping.c b/kernel/dma/mapping.c
index 16cb03d5d87d..39fac8c21643 100644
--- a/kernel/dma/mapping.c
+++ b/kernel/dma/mapping.c
@@ -1024,3 +1024,63 @@ bool dma_can_use_iova(struct dma_iova_state *state)
 	return state->use_iova;
 }
 EXPORT_SYMBOL_GPL(dma_can_use_iova);
+
+/**
+ * dma_start_range - Start a range of IOVA space
+ * @state: IOVA state
+ *
+ * Start a range of IOVA space for the given IOVA state.
+ */
+int dma_start_range(struct dma_iova_state *state)
+{
+	if (!state->use_iova)
+		return 0;
+
+	return iommu_dma_start_range(state->dev);
+}
+EXPORT_SYMBOL_GPL(dma_start_range);
+
+/**
+ * dma_end_range - End a range of IOVA space
+ * @state: IOVA state
+ *
+ * End a range of IOVA space for the given IOVA state.
+ */
+void dma_end_range(struct dma_iova_state *state)
+{
+	if (!state->use_iova)
+		return;
+
+	iommu_dma_end_range(state->dev);
+}
+EXPORT_SYMBOL_GPL(dma_end_range);
+
+/**
+ * dma_link_range_attrs - Link a range of IOVA space
+ * @state: IOVA state
+ * @phys: physical address to link
+ * @size: size of the buffer
+ * @attrs: attributes of mapping properties
+ *
+ * Link a range of IOVA space for the given IOVA state.
+ */
+dma_addr_t dma_link_range_attrs(struct dma_iova_state *state, phys_addr_t phys,
+				size_t size, unsigned long attrs)
+{
+	return iommu_dma_link_range(state, phys, size, attrs);
+}
+EXPORT_SYMBOL_GPL(dma_link_range_attrs);
+
+/**
+ * dma_unlink_range_attrs - Unlink a range of IOVA space
+ * @state: IOVA state
+ * @attrs: attributes of mapping properties
+ *
+ * Unlink a range of IOVA space for the given IOVA state.
+ */
+void dma_unlink_range_attrs(struct dma_iova_state *state, unsigned long attrs)
+{
+	iommu_dma_unlink_range(state->dev, state->addr, state->range_size,
+			       state->dir, attrs);
+}
+EXPORT_SYMBOL_GPL(dma_unlink_range_attrs);